/// <reference types="mongoose" />
/// <reference types="express" />
import { NextFunction, Request, Response } from 'express';
import { Document, Model, ModelPopulateOptions } from 'mongoose';
export interface ResourceValidation {
    name: string;
    type: string;
}
export interface ResourceDescription {
    defaultFilter?: {};
    identifier?: string;
    populations?: ModelPopulateOptions[] | string;
    selection?: string;
    sortableBy?: string[];
    sortDefault?: string;
    validations?: ResourceValidation[];
}
export declare let create: (Resource: Model<Document>, description?: ResourceDescription) => (req: Request, res: Response, next: NextFunction) => void;
export declare let read: (Resource: Model<Document>, description?: ResourceDescription) => (req: Request, res: Response, next: NextFunction) => void;
export declare let readAll: (Resource: Model<Document>, description?: ResourceDescription) => (req: Request, res: Response, next: NextFunction) => any;
export declare let update: (Resource: Model<Document>, description?: ResourceDescription) => (req: Request, res: Response, next: NextFunction) => void;
export declare let destroy: (Resource: Model<Document>, description?: ResourceDescription) => (req: Request, res: Response, next: NextFunction) => void;
